/**
 * vec - a tiny SIMD vector library in plain C99
 * 
 * Copyright (c) 2024 Paper
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
**/

#ifndef VEC_IMPL_INTEGER_H_
#define VEC_IMPL_INTEGER_H_

#cmakedefine HAVE_SYS_TYPES_H
#cmakedefine HAVE_STDDEF_H
#cmakedefine HAVE_STDINT_H

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif
#ifdef HAVE_STDDEF_H
# include <stddef.h>
#endif
#ifdef HAVE_STDINT_H
# include <stdint.h>
#endif

typedef signed char   vec_int8;
typedef @SIZE16@      vec_int16;
typedef @SIZE32@      vec_int32;
typedef @SIZE64@      vec_int64;

typedef unsigned char vec_uint8;
typedef @USIZE16@     vec_uint16;
typedef @USIZE32@     vec_uint32;
typedef @USIZE64@     vec_uint64;

/* this is only used for bitshifting right now */
typedef vec_int64     vec_intmax;
typedef vec_uint64    vec_uintmax;

typedef @USIZEPTR@    vec_uintptr;

#endif /* VEC_IMPL_INTEGER_H_ */